; -> $.minix.usr.h.aosdriver
;
; Konstanten fuer den Arthur <--> Minix Operating Sytem Driver
;
; (C) 29/11/89 Martin Patzel
;


; SWI - Nummern des Treibers

MinixSWIBase		EQU	&00100000	; niedrigste MINIX-SWI-Nummer
MX_SystemCall		EQU	MinixSWIBase+00
MX_EnableDriver		EQU	MinixSWIBase+01
MX_DisableDriver	EQU	MinixSWIBase+02
MX_EnterSVC		EQU	MinixSWIBase+03
MX_PutC			EQU	MinixSWIBase+04
MX_GetC			EQU	MinixSWIBase+05
MX_DiskIO		EQU	MinixSWIBase+06
MX_DiskParms		EQU	MinixSWIBase+07
MX_SetVector		EQU	MinixSWIBase+08
MX_Special		EQU	MinixSWIBase+09
MX_GetParameters	EQU	MinixSWIBase+10
MX_GetMemoryMap		EQU	MinixSWIBase+11
MX_GetMemoryFreeList	EQU	MinixSWIBase+12
MX_SetTranslator	EQU	MinixSWIBase+13
MX_OSMode		EQU	MinixSWIBase+14
MX_SetMemoryMap		EQU	MinixSWIBase+15


; Vektornummern fuer MX_SetVector (swi_set_vector)

SV_ClockVec		EQU	0
SV_KeybdVec		EQU	1


; Funktionsnummern fuer MX_Special (swi_special)

SP_SetLeds		EQU	0
SP_ReadTimer		EQU	1
SP_Reset		EQU	2
SP_RealTime		EQU	3


; Funktionsnummern fuer MX_PutC

PC_PutC			EQU	&00000000
PC_MoveTo		EQU	&01000000
PC_Scroll		EQU	&02000000
PC_GetWindow		EQU	&03000000

SCRL_Right		EQU	0
SCRL_Left		EQU	1
SCRL_Down		EQU	2
SCRL_Up			EQU	3

; Devicenummern fuer den Treiber

Flop_Dev		EQU	0
Hard_Dev		EQU	1
Swap_Dev		EQU	2



; Struktur fuer Infoblock eines Laufwerks (swi_diskparms)

DP_DSize	EQU	&00	; Laufwerksgroesse in Byte
DP_SSize	EQU	&04	; Sektorgroesse in Byte
DP_Size		EQU	&08	; Groesse dieser Struktur in Byte


; Struktur fuer System-Parameterblock (get_para)

GP_MinPgSize	EQU	&00	; minimale Pagegroesse in Bytes
GP_MaxPgSize	EQU	&04	; maximale Pagegroesse in Bytes
GP_ActPgSize	EQU	&08	; aktuelle Pagegroesse in Bytes
GP_CodPgSize	EQU	&0C	; log_2(act_pg_size/min_pg_size)
GP_MinPPgNum	EQU	&10	; minimale Anzahl physikalischer Pages
GP_MaxPPgNum	EQU	&14	; maximale Anzahl physikalischer Pages
GP_ActPPgNum	EQU	&18	; aktuelle Anzahl physikalischer Pages
GP_MinLPgNum	EQU	&1C	; minimale Anzahl logischer Pages
GP_MaxLPgNum	EQU	&20	; maximale Anzahl logischer Pages
GP_ActLPgNum	EQU	&24	; aktuelle Anzahl logischer Pages
GP_PhysBase	EQU	&28	; Basisadresse der physikalischen Pages
GP_PhysEnd	EQU	&2C	; Endadresse der physikalischen Pages (ausschl.)
GP_LogBase	EQU	&30	; Basisadresse der logischen Pages
GP_LogEnd	EQU	&34	; Endadresse der logischen Pages (ausschl.)
GP_FreeArea	EQU	&38	; Adresse Beginn freier Speicherbereich
GP_TopRam	EQU	&3C	; Erste Adresse ausserhalb des virt. Adr. Raums
GP_Size		EQU	&40	; Groesse dieser Struktur in Bytes


		END
