/*
 * diskio.c
 *
 * Unterstuetzung der Unix-IO-Funktionen
 *
 * (C) 12/10/90 Martin Patzel
 */

#include <stdio.h>
#include <arthur.h>
#include <string.h>

#define	MAX_FD	20		/* Maximale Anzahl geoeffneter Files */
#define	O_RDONLY 0

struct io {
	void	*fp;
} io_tab[MAX_FD];


int
open(name, mode)
char *name;
int mode;
{
	int fd;
	FILE *fp;
	
	for (fd = 3; fd < MAX_FD; fd++)
		if (io_tab[fd].fp == NULL)
		{
			if ((fp = fopen(name, "rb")) == NULL)
				return (-1);
			if (mode == O_RDONLY)
			{
				io_tab[fd].fp = fp;
				return (fd);
			}
			fclose(fp);
			if ((fp = fopen(name, "r+b")) == NULL)
				return (-1);
			io_tab[fd].fp = fp;
			return (fd);
		}
	return (-1);
}

int
close(fd)
int fd;
{
	int r;

	if (fd > 2 && io_tab[fd].fp != NULL)
	{
		r = fclose(io_tab[fd].fp);
		io_tab[fd].fp = NULL;
		return (r);
	}
	else
		return (-1);
}

int
creat(name, mode)
char *name;
int mode;
{
	int fd;
	FILE *fp;
	
	for (fd = 3; fd < MAX_FD; fd++)
		if (io_tab[fd].fp == NULL)
		{
			if ((fp = fopen(name, "w+b")) == NULL)
				return (0);
			io_tab[fd].fp = fp;
			return (fd);
		}
	return (0);
}

int
read(fd, buf, n)
int fd;
void *buf;
int n;
{
	return(fread(buf, 1, n, io_tab[fd].fp));
}


int
write(fd, buf, n)
int fd;
void *buf;
int n;
{
	int nn;
	char *cp;

	if (fd == 0) return (-1);
	if (fd <= 2)
	{
		nn = n; cp = buf;
		while (nn--)
			putchar(*cp++);
		return (n);
	}
	return(fwrite(buf, 1, n, io_tab[fd].fp));
}

long
lseek(fd, offset, mode)
int fd;
long offset;
int mode;
{
	if (fseek(io_tab[fd].fp, offset, mode) != 0)
		return (-1);
	return (ftell(io_tab[fd].fp));
}

int
mkdir(path)
char *path;
{
	art_reg_set	regs;
	char buf[256];

	strcpy(buf, "cdir "); strcat(buf, path);
	regs.r[0] = (int)buf;
	regs = art_swi(5, &regs);
	return(0);
}


/* Dummies */
void absread() {}
void abswrite() {}

