;
; Startup file for fsck
;
; (C) 23/1/90 Martin Patzel
;


		GET	$.arm.aslib.register
		GET	$.arm.aslib.arthur
		GET	$.arm.aslib.constants
		GET	$.arm.aslib.macros
		GET	^.^.arm.h.aosdriver
		GET	^.^.arm.h.asconst


;==============================================================================
		AREA	|C$$code|, CODE, READONLY
;==============================================================================

		EXPORT	start
		EXPORT	|__main|
		EXPORT	begtext
		EXPORT	putc
		EXPORT	getc
		EXPORT	diskio
		EXPORT	exit
		EXPORT	os_exit

		IMPORT	main
		IMPORT	drive
		IMPORT	partition
		IMPORT	boot_parameters

STACKSIZE	EQU	8192



;==============================================================================
; Main entry point to fsck when used in the minix bootstrapping procedure
;==============================================================================

		ENTRY
begtext
|__main|
start		LDR	SP, pstack_end		; top of stack
		LDR	SL, pstack		; lower end of stack
		BL	main			; start fsck
		LDR	R0, pboot_parameters
		LDR	R1, pkernel_text
		LDR	PC, [R1]		; jump to kernel

exit		B	start

os_exit		SWI	OS_Exit


;==============================================================================
; Putc puts an character onto the screen (char given in R0)
;==============================================================================
putc		SWI	MX_PutC+XBit
		MOVS	PC, LK


;==============================================================================
; Getc fetches any key from the keyboard, it's returned in R0
; ASCII code in bit 0-7, scancode should be in bit 16-23 (but isn't :-( )
;==============================================================================
getc		SWI	MX_GetC+XBit
		MOVS	PC, LK


;==============================================================================
; Read/write blocks from/onto disk
; diskio(RW, block_number, buffer, block_count)
; externals: drive, partition
; drive  	= 0=Floppy, 1=Harddisk, 2=Swap
; partition	= 00-FF accesses one partition on the selected drive
;==============================================================================
diskio
		STMDB	SP!, {R1-R5, LK}
		MOV	R5, R2			; buffer address
		MOV	R4, R1			; sector number
		LDIND	R2, partition
		LDIND	R1, drive
		SUB	R1, R1, #2
		SWI	MX_DiskIO+XBit
		LDMIA	SP!, {R1-R5, PC}^


pkernel_text	DCD	kernel_text
pstack		DCD	stack
pstack_end	DCD	stack_end
pdrive		DCD	drive
ppartition	DCD	partition
pboot_parameters DCD	boot_parameters



;==============================================================================
		AREA	|C$$data|
;==============================================================================

		EXPORT	|x$dataseg|
		EXPORT	begdata

|x$dataseg|
begdata


;==============================================================================
		AREA	|C$$bss|
;==============================================================================

		EXPORT	begbss
		EXPORT	kernel_text
		EXPORT	stack_end

begbss
kernel_text	DCD	0
kernel_data	DCD	0
kernel_bss	DCD	0
kernel_end	DCD	0
mm_text		DCD	0
mm_data		DCD	0
mm_bss		DCD	0
mm_end		DCD	0
fs_text		DCD	0
fs_data		DCD	0
fs_bss		DCD	0
fs_end		DCD	0
init_text	DCD	0
init_data	DCD	0
init_bss	DCD	0
init_end	DCD	0
fsck_text	DCD	0
fsck_data	DCD	0
fsck_bss	DCD	0
fsck_end	DCD	0

stack		%	STACKSIZE		; kernel stack
stack_end	DCD	0			; stack end

		END
