
#include "uart.h"
	.text
	
	.global	_InitUART
	.global _putc
	.global _puts
	.global DATA
	.global _DATA

	.text
	.align 2



	/*
	;; ********************************************************************
	;; InitUART - Initialize Serial Communications
	;; ********************************************************************
	;; Following reset, the UART is disabled. So, we do the following:
	*/
_InitUART:

	ldr	r3, UART_BASE
	mov	r1, #0
	str	r1, [r3, #UTCR3]
	mov	r1, #0x08		@ 8N1
	str	r1, [r3, #UTCR0]
	mov	r1, #BAUD_DIV
	str	r1, [r3, #UTCR2]
	mov	r1, r1, lsr #8
	str	r1, [r3, #UTCR1]
	mov	r1, #0x03		@ RXE + TXE
	str	r1, [r3, #UTCR3]
	mov	r1, #0xff		@ flush status reg
	str	r1, [r3, #UTSR0]
	MOV	pc, lr		/* All done, return*/

	/*
	;; ********************************************************************
	;; putc -- prints the character in R0
        ;;   Reads r0, writes r0 with RXSTAT, modifies r0,r1,r2
	;;********************************************************************
	*/
_putc:	

	ldr	r3, UART_BASE
	mov	r1, r0
1:	ldr	r2, [r3, #UTSR1]
	tst	r2, #1 << 2		@ UTSR1_TNF
	beq	1b
/*	teq	r1, #'\n' 
	moveq	r1, #'\r' */
	str	r1, [r3, #UTDR]
	mov	pc, lr

	/*
        ;; ********************************************************************
	;; puts -- prints the characters in R0. Must be ASCIIZ
        ;;   Reads r0, writes r0 with RXSTAT, modifies r1,r2,r3,r4,r5
	;; ********************************************************************
	*/

_puts:

	mov	r4,lr
	mov	r5, r0		/* address of the data */
	ldr	r0,[r5]
2:
	bl      _putc     
	mov     r1,r5,LSR #8    /* shift word right 8 bits*/
	ldr	r0,[r1]
	teq	r0,#0		/* check to see if its end of string. */
	bne	2
        mov     pc, r4


	.align
UART_BASE:	.long	0x80050000		@ UART3
